#! /bin/sh

generate_links()
{
#local index_file name file lineno

  index_file="$1"
  
  command='sed '
  { 
    while read file lineno name; do
      command="$command -e "\''s,\['"$name"'\],<A NAME="'"$name"'">,g'\'
      command="$command -e "\''s,&#xab;'"$name"'&#xbb;,<A HREF="'"$file"\#"$name"'">'"$name"'</A>,g'\'
    done
  } < "$index_file"

  eval "$command"
}

generate_headers()
{
#  local index_file name this_file

  index_file_generate_headers="$1"
  this_file_generate_headers=`echo $2 | sed 's,.*/,,' | sed 's,\..*$,,'`

  name_generate_headers=`grep "^$this_file_generate_headers" "$index_file_generate_headers" | head -1 | sed s,'^[^ ]* [^ ]* ,,'`
  sed -e 's,<TITLE>.*</TITLE>,<TITLE>'"$name_generate_headers"'</TITLE>,'
}


cat "$2" | generate_links "$1"  | generate_headers "$1" "$2"
